--- tarsnap-1.0.29/tar/write.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/write.c	2011-08-02 09:20:28.000000000 -0700
@@ -287,7 +287,7 @@
 	    &bsdtar->cachedir_dev, &bsdtar->cachedir_ino))
 		bsdtar_errc(bsdtar, 1, 0, archive_error_string(a));
 
-	/* Read the chunkfication cache. */
+	/* Read the chunkification cache. */
 	if (bsdtar->cachecrunch < 2) {
 		bsdtar->chunk_cache = ccache_read(bsdtar->cachedir);
 		if (bsdtar->chunk_cache == NULL)
@@ -367,6 +367,12 @@
 					bsdtar->return_value = 1;
 					goto cleanup;
 				}
+				if (*arg == '\0') {
+					bsdtar_warnc(bsdtar, 0,
+					    "Meaningless argument for -C: ''");
+					bsdtar->return_value = 1;
+					goto cleanup;
+				}
 			}
 			set_chdir(bsdtar, arg);
 		} else {
@@ -457,7 +463,13 @@
 archive_names_from_file_helper(struct bsdtar *bsdtar, const char *line)
 {
 	if (bsdtar->next_line_is_dir) {
-		set_chdir(bsdtar, line);
+		if (*line != '\0')
+			set_chdir(bsdtar, line);
+		else {
+			bsdtar_warnc(bsdtar, 0,
+			    "Meaningless argument for -C: ''");
+			bsdtar->return_value = 1;
+		}
 		bsdtar->next_line_is_dir = 0;
 	} else if (!bsdtar->option_null && strcmp(line, "-C") == 0)
 		bsdtar->next_line_is_dir = 1;
@@ -771,7 +783,7 @@
 		 * If the user did not specify --insane-filesystems, do not
 		 * cross into a new filesystem which is known to be synthetic.
 		 * Note that we will archive synthetic filesystems if we are
-		 * explcitly told to do so.
+		 * explicitly told to do so.
 		 */
 		if ((bsdtar->option_insane_filesystems == 0) &&
 		    (dev_recorded == 1) &&
@@ -797,7 +809,7 @@
 
 		/*
 		 * If user has asked us not to cross mount points,
-		 * then don't descend into into a dir on a different
+		 * then don't descend into a dir on a different
 		 * device.
 		 */
 		if (!dev_recorded) {
@@ -946,7 +958,8 @@
 			fprintf(stderr, "\n");
 	}
 	archive_entry_free(entry);
-	tree_close(tree);
+	if (tree_close(tree))
+		bsdtar_errc(bsdtar, 1, 0, "Error traversing directory tree");
 }
 
 /*
